SoGLViewingMatrixElement(3)

NAME
SoGLViewingMatrixElement - The SoGLViewingMatrixElement class is used to store the current viewing matrix.

SYNOPSIS

#include <Inventor/elements/SoGLViewingMatrixElement.h>

Inherits SoViewingMatrixElement.

  Public Member Functions
virtual void init (SoState *state)
virtual void push (SoState *state)
virtual void pop (SoState *state, const SoElement *prevTopElement)
Public Member Functions inherited from SoReplacedElement
virtual SbBool matches (const SoElement *element) const
virtual SoElement * copyMatchInfo () const
SbUniqueId getNodeId () const
virtual void print (FILE *file) const
Public Member Functions inherited from SoElement
const SoType getTypeId (void) const
int getStackIndex (void) const
void setDepth (const int depth)
int getDepth (void) const
virtual ~SoElement ()

  Static Public Member Functions
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void * createInstance (void)
static void initClass (void)
static SbUniqueId getNodeId (SoState *const state)
static SbMatrix getResetMatrix (SoState *state)
Static Public Member Functions inherited from SoViewingMatrixElement
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void * createInstance (void)
static void initClass (void)
static void set (SoState *const state, SoNode *const node, const SbMatrix &ViewingMatrix)
FIXME: write doc.
static const SbMatrix & get (SoState *const state)
FIXME: write doc.
Static Public Member Functions inherited from SoReplacedElement
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void initClass (void)
Static Public Member Functions inherited from SoElement
static void initClass (void)
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void initElements (void)
static int getNumStackIndices (void)
static SoType getIdFromStackIndex (const int stackIndex)

  Protected Member Functions
virtual ~SoGLViewingMatrixElement ()
virtual void setElt (const SbMatrix &matrix)
Protected Member Functions inherited from SoViewingMatrixElement
virtual ~SoViewingMatrixElement ()
Protected Member Functions inherited from SoReplacedElement
virtual ~SoReplacedElement ()
Protected Member Functions inherited from SoElement
SoElement (void)
void capture (SoState *const state) const
virtual void captureThis (SoState *state) const
void setTypeId (const SoType typeId)
void setStackIndex (const int index)
SoElement * getNextInStack (void) const
SoElement * getNextFree (void) const

  Additional Inherited Members
Static Protected Member Functions inherited from SoReplacedElement
static SoElement * getElement (SoState *const state, const int stackIndex, SoNode *const node)
Static Protected Member Functions inherited from SoElement
static SoElement * getElement (SoState *const state, const int stackIndex)
static const SoElement * getConstElement (SoState *const state, const int stackIndex)
static int createStackIndex (const SoType id)
Protected Attributes inherited from SoViewingMatrixElement
SbMatrix viewingMatrix
Protected Attributes inherited from SoReplacedElement
SbUniqueId nodeId
Protected Attributes inherited from SoElement
SoType typeId
int stackIndex
int depth
Static Protected Attributes inherited from SoElement
static int classStackIndex
static SoTypeList * stackToType

Detailed Description

The SoGLViewingMatrixElement class is used to store the current viewing matrix. The viewing matrix contains the inverse camera coordinate system matrix. The camera coordinate system is built from the field values in the current SoCamera (currently either SoPerspectiveCamera or SoOrthographicCamera) and any transformations prior to the camera in the scene graph.

Constructor & Destructor Documentation

  SoGLViewingMatrixElement::~SoGLViewingMatrixElement (void ) [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoGLViewingMatrixElement::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  int SoGLViewingMatrixElement::getClassStackIndex (void ) [static]
This static method returns the state stack index for the class.

  void * SoGLViewingMatrixElement::createInstance (void ) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Creates a new instance of the class type corresponding to the SoType object.

  void SoGLViewingMatrixElement::initClass (void ) [static]
Initialize relevant common data for all instances, like the type system.

  void SoGLViewingMatrixElement::init (SoState * state) [virtual]
Initializes the element to its default value. The default value is the identity matrix.

Reimplemented from SoViewingMatrixElement.

  void SoGLViewingMatrixElement::push (SoState * state) [virtual]
This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

  void SoGLViewingMatrixElement::pop (SoState * state, const SoElement * prevTopElement) [virtual]
This method is called when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

  SbUniqueId SoGLViewingMatrixElement::getNodeId (SoState *const state) [static]
Returns the node id of the current camera node. This is used by SoGLModelMatrixElement to detect a change in the viewing matrix inside an SoTransformSeparator node.

  SbMatrix SoGLViewingMatrixElement::getResetMatrix (SoState * state) [static]
Returns the matrix that should be used by SoGLModelMatrixElement when the transformation should be reset during traversal (typically when encountering an SoResetTransform node). It is not sufficient to simply load the viewing matrix, since the transformations that were applied before the camera needs to be accounted for.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
    Coin 2.0

  void SoGLViewingMatrixElement::setElt (const SbMatrix & matrix) [protected], [virtual]
Sets the current viewing matrix.

Reimplemented from SoViewingMatrixElement.

Author

Generated automatically by Doxygen for Coin from the source code.